//------------------------------------------------------------------
#property copyright "www.forex-tsd.cm"
#property link      "www.forex-tsd.cm"
//------------------------------------------------------------------
#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  LimeGreen
#property indicator_color2  LimeGreen
#property indicator_color3  PaleVioletRed
#property indicator_color4  PaleVioletRed
#property indicator_color5  DimGray
#property indicator_width1  2
#property indicator_width3  2
#property indicator_minimum 0
#property indicator_maximum 1

//
//
//
//
//

extern int Length1 =  12;
extern int Length2 =  50;
extern int Price   =   0;

double vel[];
double histouu[];
double histoud[];
double histodd[];
double histodu[];
double slope[];
double trend[];

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
   SetIndexBuffer(0,histouu); SetIndexStyle(0,DRAW_HISTOGRAM);
   SetIndexBuffer(1,histoud); SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(2,histodd); SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(3,histodu); SetIndexStyle(3,DRAW_HISTOGRAM);
   SetIndexBuffer(4,vel);
   SetIndexBuffer(5,slope);
   SetIndexBuffer(6,trend);
   IndicatorShortName("velocity ("+Length1+","+Length2+")");
   return(0);
}
int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         int limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   for(int i=limit; i>=0; i--)
   {
      vel[i]     = iVelocity(iMA(NULL,0,1,0,MODE_SMA,Price,i),Length2,i,0)-iVelocity(iMA(NULL,0,1,0,MODE_SMA,Price,i),Length1,i,1);
      histouu[i] = EMPTY_VALUE;
      histoud[i] = EMPTY_VALUE;
      histodd[i] = EMPTY_VALUE;
      histodu[i] = EMPTY_VALUE;
      trend[i]   = trend[i+1];
      slope[i]   = slope[i+1];
         if (vel[i]>0)        trend[i] =  1;
         if (vel[i]<0)        trend[i] = -1;
         if (vel[i]>vel[i+1]) slope[i] =  1;
         if (vel[i]<vel[i+1]) slope[i] = -1;
         if (trend[i]==1)
            if (slope[i]==1)
                  histouu[i] = 1;
            else  histoud[i] = 1;
         if (trend[i]==-1)
            if (slope[i]==-1)
                  histodd[i] = 1;
            else  histodu[i] = 1;
   }
   return(0);
}

  
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

double prices[][2];
double iVelocity(double price, double length, int i,int instanceNo=0)
{
   if (ArrayRange(prices,0)!=Bars) ArrayResize(prices,Bars); i=Bars-i-1;
   
      prices[i][instanceNo] = price;
      double suma = 0.0, sumwa=0;
      double sumb = 0.0, sumwb=0;

      for(int k=0; k<length; k++)
      {
         double weight = length-k;
            suma  += prices[i-k][instanceNo] * weight;
            sumb  += prices[i-k][instanceNo] * weight * weight;
            sumwa += weight;
            sumwb += weight*weight;
      }
   return(sumb/sumwb-suma/sumwa);
}